<?php
namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities\Util;
use Teknisa\MAN\Utilities\Resposta; 

class ExpImpNfceService {
    
    public $entityManager;
    
   	public function __construct(\Doctrine\ORM\EntityManager $entityManager, Util $util)  {
		$this->entityManager = $entityManager;
		$this->util = $util;
	}
	
	public function executarQuery($query, $params) {
	    
	    $retorno = new Resposta();
	    
	    $retorno->setParameters($params);
	    try {
	        $resultado = $this->entityManager->getConnection()->fetchAll($query, $params);
	        $retorno->setResult($resultado);
	        $retorno->setMessage("Query executada com sucesso. Linhas retornadas: ".$retorno->getLinhasResult());
	        $retorno->setStatus(Resposta::SUCESSO);
	    } catch (\Exception $e){
            $retorno->setMessage($e->getMessage());
            $retorno->setError(true);
            $retorno->setStatus(Resposta::ERRO);
        }
        
        return $retorno;
        
	}
	
	const GET_LINK_CERTIFICADO = "
        SELECT P.FILESERVERURL || 
		       SUBSTR(I.DSDIRCERTIFICADO, INSTR(I.DSDIRCERTIFICADO, '>')+1) DSDIRCERTIFICADO, I.CDSENHACERTIF, I.DSDIRCERTIFICADO CERTIFICADO, 
		       (SELECT DSSENHACERTNFCE FROM PARAVEND WHERE CDFILIAL = :CDFILIAL) AS DSSENHACERTNFCE
		  FROM INSCRESTAD I, PARAMGERAL P
		 WHERE I.CDINSCESTA = :CDINSCESTA";
	
	const BUSCAR_URLCHAVE = "SELECT WSSITEUFQRCODENFC FROM WEBSERVICE WHERE SGESTADO = :SGESTADO AND IDSERVICO = :IDSERVICO AND IDAMBIENTE = :IDAMBIENTE";
	
	const BUSCAR_NOTAS = "SELECT * FROM (SELECT 'N' AS IDCHECK, VE.CDFILIAL, VE.CDCAIXA, VE.CDLOJA, VE.NRSEQVENDA,NVL(ARQ.DSARQXMLNFCE, VE.DSARQXMLNFCE) AS DSARQXMLNFCE, TO_CHAR(VE.DTENTRVENDA, 'DD/MM/YYYY') DTENTRVENDA, VE.NRACESSONFCE,
       NVL(VE.CDSERIENFCE,VE.CDSERIESAT) AS CDSERIE, VE.IDTPEMISVEND, VE.NRNOTAFISCALCE, VE.IDSITUVENDA, VE.IDTPAMBNFCE, VE.NRPROTOCOLONFCE,
       VE.DTHRPROTOCONFCE, VE.IDSTATUSNFCE, VE.NRINSJURIEST, VE.DTHRPROTOCOCANC, VE.DSRAZAOCANCNFCE, VE.NRPROTOCOLOCANC, PV.NRCERTDIGNFCE, NVL(ARQ.DSARQXMLCANCNFCE, VE.DSARQXMLCANCNFCE) AS DSARQXMLCANCNFCE , VE.DSQRCODENFCE, VE.SGESTADO,
       FI.CDINSCESTA, PV.CDIDTOKENPROD, PV.CDIDTOKENHOMO, PV.CDCODSCONSPROD, PV.CDCODSCONSHOMO, FI.NMRAZSOCFILI, FI.NRINSJURFILI
    FROM VENDA VE, FILIAL FI, CAIXA CA, PARAVEND PV, ARQXMLNFCESAT ARQ
    WHERE ((INSTR(:P_CDFILIAL, FI.CDFILIAL) <> 0) OR (:P_TCDFILIAL = 'T'))
    AND ((INSTR(:P_CDCAIXA, CA.CDFILIAL||CA.CDCAIXA) <> 0) OR (:P_TCDCAIXA = 'T'))
    AND PV.CDFILIAL = FI.CDFILIAL
    AND VE.CDFILIAL = FI.CDFILIAL
    AND VE.CDFILIAL = CA.CDFILIAL
    AND VE.CDCAIXA  = CA.CDCAIXA
    AND VE.CDFILIAL = ARQ.CDFILIAL (+)
    AND VE.CDCAIXA  = ARQ.CDCAIXA (+)
    AND VE.NRSEQVENDA  = ARQ.NRSEQVENDA (+)
    AND VE.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIM
    AND ((VE.IDTPEMISVEND = 'N') OR (VE.IDTPEMISVEND = 'S'))
    AND (INSTR(:P_IDSTATUSNFCE, VE.IDSTATUSNFCE) <> 0)
    AND VE.IDTPAMBNFCE = :IDTPAMBNFCE
    AND ((INSTR(:NRNOTAFISCALCE, VE.NRNOTAFISCALCE) <> 0) OR (:NRNOTAFISCALCE = 'T'))
    ORDER BY VE.CDFILIAL, VE.CDCAIXA, VE.DTVENDA) WHERE (CDFILIAL||CDCAIXA||NRSEQVENDA||NRACESSONFCE||CDSERIE||NRNOTAFISCALCE||IDTPAMBNFCE||IDTPEMISVEND||IDSITUVENDA like :ALLFIEDLS  OR :ALLFIEDLS = 'T' )";   
}