<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class PromocaoCombinadaAnali {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function getReport($conditions){
        try{
            $params = array (
                ':DTINI'      => $conditions['DTENTRVENDA'][0], 
                ':DTFIN'      => $conditions['DTENTRVENDA'][1], 
                ':CDFILIAL'   => array_key_exists('CDFILIAL', $conditions)    ? implode('_', $conditions['CDFILIAL']) : NULL, 
                ':TCDFILIAL'  => (!array_key_exists('CDFILIAL', $conditions)) ? 'T' : NULL, 
                ':NRORG'      => $conditions['NRORG'], 
                ':TCDPRODUTO' => NULL,
                ':CDPRODLIST' => array_key_exists('CDPRODUTO', $conditions)  ? implode('_', $conditions['CDPRODUTO']) : NULL,
                ':CDARVPRODF' => array_key_exists('CDARVPRODF', $conditions) ? $conditions['CDARVPRODF'] : NULL,
                ':CDARVPRODI' => array_key_exists('CDARVPRODI', $conditions) ? $conditions['CDARVPRODI'] : NULL,
                ':PRODNIV'    => array_key_exists('PRODNIV', $conditions)    ? $conditions['PRODNIV']    : NULL
            );
            $prodPai = $this->entityManager->getConnection()->fetchAll(self::GET_PROD_PAI, $params);
            unset($params);
            $resposta = array();
            $rowFilho = array();
            if($prodPai){
                foreach($prodPai as $prod){
                    $params = array(
                        ':DTINI'      => $conditions['DTENTRVENDA'][0],
                        ':DTFIN'      => $conditions['DTENTRVENDA'][1],
                        ':NRSEQVENDA' => $prod['NRSEQVENDA'],
                        ':CDPRODPAI'  => $prod['CDPRODPAI'],
                        ':TIPO'       => $prod['TIPO'],
                        ':CDFILIAL'   => $prod['CDFILIAL']
                    );
                    $prodFilho   = $this->entityManager->getConnection()->fetchAll(self::GET_PROD_FILHO, $params);
                    $nrItemPromo = $this->entityManager->getConnection()->fetchAll(self::GET_NR_ITEM_PROMO, $params);
                    if($prodFilho){
                        foreach ($prodFilho as $prodSon){
                            $itemPromo = array_key_exists('NRITEMPROMO', $nrItemPromo[0]) ? $nrItemPromo[0]['NRITEMPROMO'] : 1;
                            $rowFilho['LABELFILIAL']  = $prod["CDFILIAL"]." - ".$prod["NMFILIAL"];
                     		$rowFilho['CDSUBPRODFIL'] = $prodSon['CDSUBPRODFIL'];
                     		$rowFilho['NMSUBPRODFIL'] = $prodSon['NMSUBPRODFIL'];
                     		$rowFilho['QUANTPRODFIL'] = $prodSon['QUANTPRODFIL'];
                     		$rowFilho['TOTALVENDFIL'] = $prodSon['TOTALVENDFIL'];
                     		$rowFilho['LABELPRODPROMOCAO'] = $prod['CDPRODPAI'].' '.$prod['NMPRODPAI'].' '.$prod['CDBARPRODPAI'].
                     		' | Valor Vendido '.$prod['TOTALVENDA'].' | Nr. Venda '.$prod['NRSEQVENDA'].' | Data '.substr($prod['DTENTRVENDA'], 0, 10).' | Quantidade Vendida '.
                     		substr(($prod['QUANTPRODPAI'] / $itemPromo), 0, 5).' | Cupom '.$prod['NRCUPOMFIS'].' | Caixa '.$prod['CDCAIXA'];
                     		array_push($resposta, $rowFilho);
                        }
                    }
                }
            }
            return $resposta;
        } catch(Exception $e){
            throw $e;
        }
    }
    
    
    
    const GET_PROD_PAI = "
        SELECT IT.CDPRODUTO AS CDPRODPAI, PR.NMPRODUTO AS NMPRODPAI, '1' AS TIPO, PR.CDARVPROD, PR.CDBARPRODUTO AS CDBARPRODPAI,
          IT.CDFILIAL, FI.NMFILIAL, SUM(IT.QTPRODVEND) AS QUANTPRODPAI, VE.NRSEQVENDA, VE.CDCAIXA, VE.NRCUPOMFIS, VE.DTENTRVENDA,
          SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2)) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0)) AS TOTALVENDA
        FROM ITEMVENDA IT 
         JOIN VENDA VE
          ON (IT.CDFILIAL = VE.CDFILIAL)  
           AND (IT.CDCAIXA = VE.CDCAIXA)  
           AND (IT.NRSEQVENDA  = VE.NRSEQVENDA)
          JOIN PRODUTO PR
           ON (IT.CDPRODUTO = PR.CDPRODUTO)
          JOIN FILIAL FI
           ON (IT.CDFILIAL = FI.CDFILIAL)
        WHERE (IT.CDPRODUTO   = IT.CDPRODPROMOCAO)
          AND (VE.IDSITUVENDA = 'O')
          AND (EXISTS (SELECT ES.CDFILIAL
                    FROM ITEMVENDAEST ES
                    WHERE (ES.CDFILIAL = IT.CDFILIAL)
                       AND (ES.CDCAIXA = IT.CDCAIXA)
                       AND (ES.NRSEQVENDA = IT.NRSEQVENDA)
                       AND (ES.NRSEQUITVEND = IT.NRSEQUITVEND)
                  )
           )
          AND (VE.DTENTRVENDA BETWEEN :DTINI AND :DTFIN)  
          AND (((((INSTR(:CDPRODLIST, PR.CDPRODUTO) > 0 ) OR (PR.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF ))) OR (PR.CDARVPROD LIKE :PRODNIV)) OR (:TCDPRODUTO = 'T'))
          AND ((INSTR(:CDFILIAL, IT.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
        GROUP BY IT.CDFILIAL, FI.NMFILIAL, IT.CDPRODUTO, PR.NMPRODUTO, PR.CDARVPROD, PR.CDBARPRODUTO, VE.NRSEQVENDA, VE.CDCAIXA,
          VE.NRCUPOMFIS, VE.DTENTRVENDA
        
        UNION
        
        SELECT IT.CDPRODPROMOCAO AS CDPRODPAI, PR.NMPRODUTO AS NMPRODPAI, '2' AS TIPO, PR.CDARVPROD, PR.CDBARPRODUTO AS CDBARPRODPAI,
          IT.CDFILIAL, FI.NMFILIAL, SUM(IT.QTPRODVEND) AS QUANTPRODPAI, VE.NRSEQVENDA, VE.CDCAIXA, VE.NRCUPOMFIS, VE.DTENTRVENDA,
          SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2)) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0)) AS TOTALVENDA
        FROM ITEMVENDA IT
         JOIN PRODUTO PR
          ON (IT.CDPRODPROMOCAO = PR.CDPRODUTO )
         JOIN VENDA VE
          ON (IT.CDFILIAL = VE.CDFILIAL)
           AND (IT.CDCAIXA = VE.CDCAIXA)
           AND (IT.NRSEQVENDA = VE.NRSEQVENDA)
         JOIN FILIAL FI
          ON (IT.CDFILIAL = FI.CDFILIAL)
        WHERE (VE.IDSITUVENDA = 'O')
          AND (IT.CDPRODPROMOCAO IS NOT NULL)
          AND (NOT EXISTS (SELECT ES.CDFILIAL
                          FROM ITEMVENDAEST ES
                          WHERE (ES.CDFILIAL   = IT.CDFILIAL)
                           AND (ES.CDCAIXA    = IT.CDCAIXA)
                           AND (ES.NRSEQVENDA = IT.NRSEQVENDA)
                           AND (ES.NRSEQUITVEND = IT.NRSEQUITVEND)
                        )
              )
          AND (VE.DTENTRVENDA BETWEEN :DTINI AND :DTFIN)
          AND (((((INSTR(:CDPRODLIST, PR.CDPRODUTO) > 0 ) OR (PR.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF ))) OR (PR.CDARVPROD LIKE :PRODNIV)) OR (:TCDPRODUTO = 'T'))
          AND ((INSTR(:CDFILIAL, IT.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
        GROUP BY IT.CDFILIAL, FI.NMFILIAL, IT.CDPRODPROMOCAO, PR.NMPRODUTO, PR.CDARVPROD, PR.CDBARPRODUTO, VE.NRSEQVENDA, VE.CDCAIXA,
          VE.NRCUPOMFIS, VE.DTENTRVENDA
        ORDER BY 6, 12, 9, 4
    ";
    
    const GET_PROD_FILHO = "
        SELECT PR.CDARVPROD AS CDSUBPRODFIL, ES.CDPRODUTO, PR.NMPRODUTO AS NMSUBPRODFIL, PR.CDBARPRODUTO AS CDBARPRODFIL, ES.NRSEQVENDA, SUM(ES.QTITVENDAEST) AS QUANTPRODFIL, 
           SUM(TRUNC(ES.VRUNVENDAEST * ES.QTITVENDAEST,2) - NVL(ES.VRDESITVENDAEST,0)) AS TOTALVENDFIL
        FROM ITEMVENDAEST ES, VENDA VE, PRODUTO PR, ITEMVENDA IT
        WHERE (IT.CDFILIAL = ES.CDFILIAL)
           AND (IT.CDCAIXA = ES.CDCAIXA)
           AND (IT.NRSEQVENDA = ES.NRSEQVENDA)
           AND (IT.NRSEQUITVEND = ES.NRSEQUITVEND)
           AND (IT.CDFILIAL = VE.CDFILIAL)
           AND (IT.CDCAIXA = VE.CDCAIXA) 
           AND (IT.NRSEQVENDA = VE.NRSEQVENDA)
           AND (VE.IDSITUVENDA = 'O')
           AND (ES.CDPRODUTO = PR.CDPRODUTO) 
           AND (IT.CDPRODUTO = IT.CDPRODPROMOCAO)
           AND (IT.CDFILIAL  = :CDFILIAL) 
           AND(IT.CDPRODPROMOCAO = :CDPRODPAI) 
           AND (:TIPO = '1') 
           AND (VE.DTENTRVENDA BETWEEN :DTINI AND :DTFIN)
        GROUP BY PR.CDARVPROD, ES.CDPRODUTO, PR.NMPRODUTO, PR.CDBARPRODUTO, ES.NRSEQVENDA
        
        UNION
        
        SELECT PR.CDARVPROD AS CDSUBPRODFIL, IT.CDPRODUTO, PR.NMPRODUTO AS NMSUBPRODFIL, PR.CDBARPRODUTO AS CDBARPRODFIL,
          IT.NRSEQVENDA, SUM(IT.QTPRODVEND) AS QUANTPRODFIL, 
          SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2)) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0)) AS TOTALVENDFIL
        FROM ITEMVENDA IT, VENDA VE, PRODUTO PR
        WHERE (VE.CDFILIAL = :CDFILIAL)
           AND (VE.CDFILIAL = IT.CDFILIAL) 
           AND (VE.CDCAIXA = IT.CDCAIXA) 
           AND (VE.NRSEQVENDA = IT.NRSEQVENDA)
           AND (VE.IDSITUVENDA = 'O') 
           AND (IT.CDPRODUTO = PR.CDPRODUTO)
           AND (IT.NRSEQVENDA = :NRSEQVENDA) 
           AND (IT.CDPRODPROMOCAO = :CDPRODPAI) 
           AND (:TIPO = '2') 
           AND (VE.DTENTRVENDA BETWEEN :DTINI AND :DTFIN)
        GROUP BY PR.CDARVPROD, IT.CDPRODUTO, PR.NMPRODUTO, PR.CDBARPRODUTO, IT.NRSEQVENDA
        ORDER BY 6 DESC
    ";
    
    const GET_NR_ITEM_PROMO = "
        SELECT NVL(SUM(QTPRGRUPPROMOC),1) AS NRITEMPROMO
        FROM  GRUPROMOCPROD
        WHERE (CDPRODPROMOCAO = :CDPRODPAI)
            AND (:TIPO = '2')
    ";
	
}
